Modules | Functions
Functions
Peripheral Driver » HAL Driver » HAL | Peripheral Driver » HAL Driver » BR

## Modules
| Initialization and De-initialization Functions
| Initialization and de-initialization functions.
| IRQ Handler and Callbacks
| IRQ Handler and Callbacks functions.
| HAL Control functions
| HAL Control functions.
| Initialization, De-initialization
| Initialization , de-initialization and Callback registration Functions.
| Callback Structures

## Functions
hal_status_t | hal_init_ext (void)
| This function configures time base source, NVIC and Low level hardware. More...
hal_status_t | hal_deinit_ext (void)
| This function de-initializes common part of the HAL and stops the source of time base. More...
void | hal_register_callback (hal_callback_t *hal_callback)
| This function registers the callback function to the ROM area. More...
hal_status_t | hal_adc_init_ext (adc_handle_t *p_adc)
| Initialize the ADC according to the specified parameters in the adc_init_t and initialize the associated handle. More...
hal_status_t | hal_adc_deinit_ext (adc_handle_t *p_adc)
| De-initialize the ADC peripheral. More...
void | hal_adc_register_callback (hal_adc_callback_t *adc_callback)
| This function registers the callback function to the ROM area. More...
void | hal_aon_gpio_init_ext (aon_gpio_init_t *p_aon_gpio_init)
| Initialize the AON_GPIOx peripheral according to the specified parameters in the aon_gpio_init_t. More...
void | hal_aon_gpio_deinit_ext (uint32_t aon_gpio_pin)
| De-initialize the AON_GPIOx peripheral registers to their default reset values. More...
void | hal_aon_gpio_register_callback (hal_aon_gpio_callback_t *aon_gpio_callback)
| This function registers the callback function to the ROM area. More...
hal_status_t | hal_aon_wdt_init_ext (aon_wdt_handle_t *p_aon_wdt)
| Initialize the AON_WDT according to the specified parameters in the wdt_init_t of associated handle. More...
hal_status_t | hal_aon_wdt_deinit_ext (aon_wdt_handle_t *p_aon_wdt)
| De-initialize the AON_WDT peripheral. More...
void | hal_aon_wdt_register_callback (hal_aon_wdt_callback_t *aon_wdt_callback)
| This function registers the callback function to the ROM area. More...
hal_status_t | hal_calendar_init_ext (calendar_handle_t *p_calendar)
| Initialize the CALENDAR according to the specified parameters in the calendar_init_t of associated handle. More...
hal_status_t | hal_calendar_deinit_ext (calendar_handle_t *p_calendar)
| De-initialize the CALENDAR peripheral. More...
void | hal_calendar_register_callback (hal_calendar_callback_t *calendar_callback)
| This function registers the callback function to the ROM area. More...
hal_status_t | hal_dual_timer_base_init_ext (dual_timer_handle_t *p_dual_timer)
| Initialize the DUAL TIMER according to the specified parameters in the dual_timer_init_t and initialize the associated handle. More...
hal_status_t | hal_dual_timer_base_deinit_ext (dual_timer_handle_t *p_dual_timer)
| De-initialize the DUAL TIMER peripheral. More...
void | hal_dual_timer_register_callback (hal_dual_timer_callback_t *dual_timer_callback)
| This function registers the callback function to the ROM area. More...
void | hal_gpio_init_ext (gpio_regs_t *GPIOx, gpio_init_t *p_gpio_init)
| Initialize the GPIOx peripheral according to the specified parameters in the p_gpio_init. More...
void | hal_gpio_deinit_ext (gpio_regs_t *GPIOx, uint32_t gpio_pin)
| De-initialize the GPIOx peripheral registers to their default reset values. More...
void | hal_gpio_register_callback (hal_gpio_callback_t *gpio_callback)
| This function registers the callback function to the ROM area. More...
hal_status_t | hal_i2c_init_ext (i2c_handle_t *p_i2c)
| Initializes the I2C according to the specified parameters in the i2c_init_t and initialize the associated handle. More...
hal_status_t | hal_i2c_deinit_ext (i2c_handle_t *p_i2c)
| De-initialize the I2C peripheral. More...
void | hal_i2c_register_callback (hal_i2c_callback_t *i2c_callback)
| This function registers the callback function to the ROM area. More...
void | hal_msio_init_ext (msio_pad_t MSIOx, msio_init_t *p_msio_init)
| Initialize the MSIOx peripheral according to the specified parameters in the msio_init_t. More...
void | hal_msio_deinit_ext (msio_pad_t MSIOx, uint32_t msio_pin)
| De-initialize the MSIOx peripheral registers to their default reset values. More...
void | hal_msio_register_callback (hal_msio_callback_t *msio_callback)
| This function registers the callback function to the ROM area. More...
hal_status_t | hal_pwm_init_ext (pwm_handle_t *p_pwm)
| Initialize the PWM mode according to the specified parameters in the pwm_init_t and initialize the associated handle. More...
hal_status_t | hal_pwm_deinit_ext (pwm_handle_t *p_pwm)
| De-initialize the PWM peripheral. More...
void | hal_pwm_register_callback (hal_pwm_callback_t *pwm_callback)
| This function registers the callback function to the ROM area. More...
hal_status_t | hal_pwr_config_timer_wakeup_ext (uint8_t mode, uint32_t value)
| Configure the AON Sleep Timer mode, count and start used to wakeup MCU. More...
void | hal_pwr_register_timer_elaspsed_handler (pwr_slp_elapsed_handler_t pwr_slp_elapsed_hander)
| This function registers the callback function to the ROM area. More...
hal_status_t | hal_spi_init_ext (spi_handle_t *p_spi)
| Initialize the SPI according to the specified parameters in the spi_init_t and initialize the associated handle. More...
hal_status_t | hal_spi_deinit_ext (spi_handle_t *p_spi)
| De-initialize the SPI peripheral. More...
void | hal_spi_register_callback (hal_spi_callback_t *spi_callback)
| This function registers the callback function to the ROM area. More...
hal_status_t | hal_timer_base_init_ext (timer_handle_t *p_timer)
| Initialize the TIMER according to the specified parameters in the timer_init_t and initialize the associated handle. More...
hal_status_t | hal_timer_base_deinit_ext (timer_handle_t *p_timer)
| De-initialize the TIMER peripheral. More...
void | hal_timer_register_callback (hal_timer_base_callback_t *timer_base_callback)
| This function registers the callback function to the ROM area. More...
hal_status_t | hal_uart_init_ext (uart_handle_t *p_uart)
| Initialize the UART according to the specified parameters in the uart_init_t and initialize the associated handle. More...
hal_status_t | hal_uart_deinit_ext (uart_handle_t *p_uart)
| De-initialize the UART peripheral. More...
void | hal_uart_register_callback (hal_uart_callback_t *uart_callback)
| This function registers the callback function to the ROM area. More...
hal_status_t | hal_wdt_init_ext (wdt_handle_t *p_wdt)
| Initialize the WDT according to the specified parameters in the wdt_init_t of associated handle. More...
hal_status_t | hal_wdt_deinit_ext (wdt_handle_t *p_wdt)
| De-initialize the WDT peripheral. More...
void | hal_wdt_register_callback (hal_wdt_callback_t *wdt_callback)
| This function registers the callback function to the ROM area. More...
hal_status_t | hal_xqspi_init_ext (xqspi_handle_t *p_xqspi)
| Initialize the XQSPI according to the specified parameters in the xqspi_init_t and initialize the associated handle. More...
hal_status_t | hal_xqspi_deinit_ext (xqspi_handle_t *p_xqspi)
| De-initialize the XQSPI peripheral. More...
void | hal_xqspi_register_callback (hal_xqspi_callback_t *xqspi_callback)
| This function registers the callback function to the ROM area. More...
hal_status_t | hal_efuse_init_ext (efuse_handle_t *p_efuse)
| Initialize the eFuse according to the specified parameters in the efuse_init_t and initialize the associated handle. More...
hal_status_t | hal_efuse_deinit_ext (efuse_handle_t *p_efuse)
| De-initialize the eFuse peripheral. More...
void | hal_efuse_register_callback (hal_efuse_callback_t *efuse_callback)
| This function registers the callback function to the ROM area. More...
hal_status_t | hal_rng_init_ext (rng_handle_t *p_rng)
| Initialize the RNG according to the specified parameters in the rng_init_t of associated handle. More...
hal_status_t | hal_rng_deinit_ext (rng_handle_t *p_rng)
| De-initialize the RNG peripheral. More...
void | hal_rng_register_callback (hal_rng_callback_t *rng_callback)
| This function registers the callback function to the ROM area. More...
hal_status_t | hal_comp_init_ext (comp_handle_t *p_comp)
| Initialize the COMP according to the specified parameters in the comp_init_t and initialize the associated handle. More...
hal_status_t | hal_comp_deinit_ext (comp_handle_t *p_comp)
| De-initialize the COMP peripheral. More...
void | hal_comp_register_callback (hal_comp_callback_t *comp_callback)
| This function registers the callback function to the ROM area. More...

## Detailed Description

## Function Documentation

## ◆ hal_adc_deinit_ext()

hal_status_t hal_adc_deinit_ext | ( | adc_handle_t * | p_adc | ) |

De-initialize the ADC peripheral.

Parameters

  [in] | p_adc | Pointer to an ADC handle which contains the configuration information for the specified ADC module.

Note
  The function will call the hal_adc_deinit function to De-initialize the HAL ADC.

Return values

  HAL_OK | Operation is OK.
  HAL_ERROR | Parameter error or operation not supported.
  HAL_BUSY | Driver is busy.
  HAL_TIMEOUT | Timeout occurred.

## ◆ hal_adc_init_ext()

hal_status_t hal_adc_init_ext | ( | adc_handle_t * | p_adc | ) |

Initialize the ADC according to the specified parameters in the adc_init_t and initialize the associated handle.

Parameters

  [in] | p_adc | Pointer to an ADC handle which contains the configuration information for the specified ADC module.

Note
  The function will call the hal_adc_init function to initialize the HAL ADC.

Return values

  HAL_OK | Operation is OK.
  HAL_ERROR | Parameter error or operation not supported.
  HAL_BUSY | Driver is busy.
  HAL_TIMEOUT | Timeout occurred.

## ◆ hal_adc_register_callback()

void hal_adc_register_callback | ( | hal_adc_callback_t * | adc_callback | ) |

This function registers the callback function to the ROM area.

Note
  This function needs to be called before hal_adc_init.

Parameters

  [in] | adc_callback | Pointer to callback structure function. hal_adc_callback_t

## ◆ hal_aon_gpio_deinit_ext()

void hal_aon_gpio_deinit_ext | ( | uint32_t | aon_gpio_pin | ) |

De-initialize the AON_GPIOx peripheral registers to their default reset values.

Note
  The function will call the hal_aon_gpio_deinit function to De-initialize the HAL AON GPIO.

Parameters

  [in] | aon_gpio_pin | Specifies the port bit to be written. This parameter can be a combination of the following values: AON_GPIO_PIN_0 AON_GPIO_PIN_1 AON_GPIO_PIN_2 AON_GPIO_PIN_3 AON_GPIO_PIN_4 AON_GPIO_PIN_5 AON_GPIO_PIN_ALL

## ◆ hal_aon_gpio_init_ext()

void hal_aon_gpio_init_ext | ( | aon_gpio_init_t * | p_aon_gpio_init | ) |

Initialize the AON_GPIOx peripheral according to the specified parameters in the aon_gpio_init_t.

Note
  The function will call the hal_aon_gpio_init function to initialize the HAL AON GPIO.

Parameters

  [in] | p_aon_gpio_init | Pointer to an aon_gpio_init_t structure that contains the configuration information for the specified AON_GPIO peripheral port.

## ◆ hal_aon_gpio_register_callback()

void hal_aon_gpio_register_callback | ( | hal_aon_gpio_callback_t * | aon_gpio_callback | ) |

This function registers the callback function to the ROM area.

Note
  This function needs to be called before hal_aon_gpio_init.

Parameters

  [in] | aon_gpio_callback | Pointer to callback structure function. hal_aon_gpio_callback_t

## ◆ hal_aon_wdt_deinit_ext()

hal_status_t hal_aon_wdt_deinit_ext | ( | aon_wdt_handle_t * | p_aon_wdt | ) |

De-initialize the AON_WDT peripheral.

Parameters

  [in] | p_aon_wdt | AON_WDT handle.

Note
  The function will call the hal_aon_wdt_deinit function to De-initialize the HAL AON WDT.

Return values

  HAL_OK | Operation is OK.
  HAL_ERROR | Parameter error or operation not supported.
  HAL_BUSY | Driver is busy.
  HAL_TIMEOUT | Timeout occurred.

## ◆ hal_aon_wdt_init_ext()

hal_status_t hal_aon_wdt_init_ext | ( | aon_wdt_handle_t * | p_aon_wdt | ) |

Initialize the AON_WDT according to the specified parameters in the wdt_init_t of associated handle.

Parameters

  [in] | p_aon_wdt | Pointer to a AON_WDT handle which contains the configuration information for the specified AON_WDT module.

Note
  The function will call the hal_aon_wdt_init function to initialize the HAL AON WDT.

Return values

  HAL_OK | Operation is OK.
  HAL_ERROR | Parameter error or operation not supported.
  HAL_BUSY | Driver is busy.
  HAL_TIMEOUT | Timeout occurred.

## ◆ hal_aon_wdt_register_callback()

void hal_aon_wdt_register_callback | ( | hal_aon_wdt_callback_t * | aon_wdt_callback | ) |

This function registers the callback function to the ROM area.

Note
  This function needs to be called before hal_aon_wdt_init.

Parameters

  [in] | aon_wdt_callback | Pointer to callback structure function. hal_aon_wdt_callback_t.

## ◆ hal_calendar_deinit_ext()

hal_status_t hal_calendar_deinit_ext | ( | calendar_handle_t * | p_calendar | ) |

De-initialize the CALENDAR peripheral.

Parameters

  [in] | p_calendar | CALENDAR handle.

Note
  The function will call the hal_calendar_deinit function to De-initialize the HAL CALENDER.

Return values

  HAL_OK | Operation is OK.
  HAL_ERROR | Parameter error or operation not supported.
  HAL_BUSY | Driver is busy.
  HAL_TIMEOUT | Timeout occurred.

## ◆ hal_calendar_init_ext()

hal_status_t hal_calendar_init_ext | ( | calendar_handle_t * | p_calendar | ) |

Initialize the CALENDAR according to the specified parameters in the calendar_init_t of associated handle.

Parameters

  [in] | p_calendar | Pointer to a CALENDAR handle which contains the configuration information for the specified CALENDAR module.

Note
  The function will call the hal_calendar_init function to initialize the HAL CALENDER.

Return values

  HAL_OK | Operation is OK.
  HAL_ERROR | Parameter error or operation not supported.
  HAL_BUSY | Driver is busy.
  HAL_TIMEOUT | Timeout occurred.

## ◆ hal_calendar_register_callback()

void hal_calendar_register_callback | ( | hal_calendar_callback_t * | calendar_callback | ) |

This function registers the callback function to the ROM area.

Note
  This function needs to be called before hal_calendar_init.

Parameters

  [in] | calendar_callback | Pointer to callback structure function. hal_calendar_callback_t

## ◆ hal_comp_deinit_ext()

hal_status_t hal_comp_deinit_ext | ( | comp_handle_t * | p_comp | ) |

De-initialize the COMP peripheral.

Parameters

  [in] | p_comp | Pointer to a COMP handle which contains the configuration information for the specified COMP module.

Note
  The function will call the hal_comp_deinit function to De-initialize the HAL COMP.

Return values

  HAL_OK | Operation is OK.
  HAL_ERROR | Parameter error or operation not supported.
  HAL_BUSY | Driver is busy.
  HAL_TIMEOUT | Timeout occurred.

## ◆ hal_comp_init_ext()

hal_status_t hal_comp_init_ext | ( | comp_handle_t * | p_comp | ) |

Initialize the COMP according to the specified parameters in the comp_init_t and initialize the associated handle.

Parameters

  [in] | p_comp | Pointer to a COMP handle which contains the configuration information for the specified COMP module.

Note
  The function will call the hal_comp_init function to initialize the HAL COMP.

Return values

  HAL_OK | Operation is OK.
  HAL_ERROR | Parameter error or operation not supported.
  HAL_BUSY | Driver is busy.
  HAL_TIMEOUT | Timeout occurred.

## ◆ hal_comp_register_callback()

void hal_comp_register_callback | ( | hal_comp_callback_t * | comp_callback | ) |

This function registers the callback function to the ROM area.

Note
  This function needs to be called before hal_comp_init.

Parameters

  [in] | comp_callback | Pointer to callback structure function. hal_comp_callback_t

## ◆ hal_deinit_ext()

hal_status_t hal_deinit_ext | ( | void |  | ) |

This function de-initializes common part of the HAL and stops the source of time base.

Note
  This function is optional. The function will call the hal_deinit function to De-initialize the HAL.

Return values

  HAL_OK | Operation is OK.
  HAL_ERROR | Parameter error or operation not supported.
  HAL_BUSY | Driver is busy.
  HAL_TIMEOUT | Timeout occurred.

## ◆ hal_dual_timer_base_deinit_ext()

hal_status_t hal_dual_timer_base_deinit_ext | ( | dual_timer_handle_t * | p_dual_timer | ) |

De-initialize the DUAL TIMER peripheral.

Parameters

  [in] | p_dual_timer | Pointer to a DUAL_TIM handle which contains the configuration information for the specified DUAL TIMER.

Note
  The function will call the hal_dual_timer_base_deinit function to De-initialize the HAL DUAL TIMER.

Return values

  HAL_OK | Operation is OK.
  HAL_ERROR | Parameter error or operation not supported.
  HAL_BUSY | Driver is busy.
  HAL_TIMEOUT | Timeout occurred.

## ◆ hal_dual_timer_base_init_ext()

hal_status_t hal_dual_timer_base_init_ext | ( | dual_timer_handle_t * | p_dual_timer | ) |

Initialize the DUAL TIMER according to the specified parameters in the dual_timer_init_t and initialize the associated handle.

Parameters

  [in] | p_dual_timer | Pointer to a DUAL_TIMER handle which contains the configuration information for the specified DUAL TIMER.

Note
  The function will call the hal_dual_timer_base_init function to initialize the HAL DUAL TIMER.

Return values

  HAL_OK | Operation is OK.
  HAL_ERROR | Parameter error or operation not supported.
  HAL_BUSY | Driver is busy.
  HAL_TIMEOUT | Timeout occurred.

## ◆ hal_dual_timer_register_callback()

void hal_dual_timer_register_callback | ( | hal_dual_timer_callback_t * | dual_timer_callback | ) |

This function registers the callback function to the ROM area.

Note
  This function needs to be called before hal_dual_timer_base_init.

Parameters

  [in] | dual_timer_callback | Pointer to callback structure function. hal_dual_timer_callback_t

## ◆ hal_efuse_deinit_ext()

hal_status_t hal_efuse_deinit_ext | ( | efuse_handle_t * | p_efuse | ) |

De-initialize the eFuse peripheral.

Parameters

  [in] | p_efuse | Pointer to a eFuse handle which contains the configuration information for the specified eFuse module.

Note
  The function will call the hal_efuse_deinit function to De-initialize the HAL EFUSE.

Return values

  HAL_OK | Operation is OK.
  HAL_ERROR | Parameter error or operation not supported.
  HAL_BUSY | Driver is busy.
  HAL_TIMEOUT | Timeout occurred.

## ◆ hal_efuse_init_ext()

hal_status_t hal_efuse_init_ext | ( | efuse_handle_t * | p_efuse | ) |

Initialize the eFuse according to the specified parameters in the efuse_init_t and initialize the associated handle.

Parameters

  [in] | p_efuse | Pointer to a eFuse handle which contains the configuration information for the specified eFuse module.

Note
  The function will call the hal_efuse_init function to initialize the HAL EFUSE.

Return values

  HAL_OK | Operation is OK.
  HAL_ERROR | Parameter error or operation not supported.
  HAL_BUSY | Driver is busy.
  HAL_TIMEOUT | Timeout occurred.

## ◆ hal_efuse_register_callback()

void hal_efuse_register_callback | ( | hal_efuse_callback_t * | efuse_callback | ) |

This function registers the callback function to the ROM area.

Note
  This function needs to be called before hal_efuse_init.

Parameters

  [in] | efuse_callback | Pointer to callback structure function. hal_efuse_callback_t

## ◆ hal_gpio_deinit_ext()

void hal_gpio_deinit_ext | ( | gpio_regs_t * | GPIOx,
|  | uint32_t | gpio_pin
| ) |  |

De-initialize the GPIOx peripheral registers to their default reset values.

Note
  The function will call the hal_gpio_deinit function to De-initialize the HAL GPIO.

Parameters

  [in] | GPIOx | Where x can be (0, 1) to select the GPIO peripheral port for GR533x device
  [in] | gpio_pin | Specifies the port bit to be written. This parameter can be a combination of the following values: GPIO_PIN_0 GPIO_PIN_1 GPIO_PIN_2 GPIO_PIN_3 GPIO_PIN_4 GPIO_PIN_5 GPIO_PIN_6 GPIO_PIN_7 GPIO_PIN_8 GPIO_PIN_9 GPIO_PIN_10 GPIO_PIN_11 GPIO_PIN_12 GPIO_PIN_13 GPIO_PIN_ALL

## ◆ hal_gpio_init_ext()

void hal_gpio_init_ext | ( | gpio_regs_t * | GPIOx,
|  | gpio_init_t * | p_gpio_init
| ) |  |

Initialize the GPIOx peripheral according to the specified parameters in the p_gpio_init.

Note
  The function will call the hal_gpio_init function to initialize the HAL GPIO.

Parameters

  [in] | GPIOx | Where x can be (0, 1) to select the GPIO peripheral port
  [in] | p_gpio_init | Pointer to a gpio_init_t structure that contains the configuration information for the specified GPIO peripheral port.

## ◆ hal_gpio_register_callback()

void hal_gpio_register_callback | ( | hal_gpio_callback_t * | gpio_callback | ) |

This function registers the callback function to the ROM area.

Note
  This function needs to be called before hal_gpio_init.

Parameters

  [in] | gpio_callback | Pointer to callback structure function. hal_gpio_callback_t

## ◆ hal_i2c_deinit_ext()

hal_status_t hal_i2c_deinit_ext | ( | i2c_handle_t * | p_i2c | ) |

De-initialize the I2C peripheral.

Parameters

  [in] | p_i2c | Pointer to an I2C handle which contains the configuration information for the specified I2C.

Note
  The function will call the hal_i2c_deinit function to De-initialize the HAL I2C.

Return values

  HAL_OK | Operation is OK.
  HAL_ERROR | Parameter error or operation not supported.
  HAL_BUSY | Driver is busy.
  HAL_TIMEOUT | Timeout occurred.

## ◆ hal_i2c_init_ext()

hal_status_t hal_i2c_init_ext | ( | i2c_handle_t * | p_i2c | ) |

Initializes the I2C according to the specified parameters in the i2c_init_t and initialize the associated handle.

Parameters

  [in] | p_i2c | Pointer to an I2C handle which contains the configuration information for the specified I2C.

Note
  The function will call the hal_i2c_init function to initialize the HAL I2C.

Return values

  HAL_OK | Operation is OK.
  HAL_ERROR | Parameter error or operation not supported.
  HAL_BUSY | Driver is busy.
  HAL_TIMEOUT | Timeout occurred.

## ◆ hal_i2c_register_callback()

void hal_i2c_register_callback | ( | hal_i2c_callback_t * | i2c_callback | ) |

This function registers the callback function to the ROM area.

Note
  This function needs to be called before hal_i2c_init.

Parameters

  [in] | i2c_callback | Pointer to callback structure function. hal_i2c_callback_t

## ◆ hal_init_ext()

hal_status_t hal_init_ext | ( | void |  | ) |

This function configures time base source, NVIC and Low level hardware.

Note
  This function is called at the beginning of program after reset and before the clock configuration. The SysTick configuration is based on AHB clock. When the time base configuration is done, time base tick starts incrementing. In the default implementation, SysTick is used as source of time base. The tick variable is incremented each 1ms in its ISR. The function will call the hal_init function to initialize the HAL.

Return values

  HAL_OK | Operation is OK.
  HAL_ERROR | Parameter error or operation not supported.
  HAL_BUSY | Driver is busy.
  HAL_TIMEOUT | Timeout occurred.

## ◆ hal_msio_deinit_ext()

void hal_msio_deinit_ext | ( | msio_pad_t | MSIOx,
|  | uint32_t | msio_pin
| ) |  |

De-initialize the MSIOx peripheral registers to their default reset values.

Note
  The function will call the hal_msio_deinit function to De-initialize the HAL MSIO.

Parameters

  [in] | MSIOx | MSIO peripheral port.
  [in] | msio_pin | Specifies the port bit to be written. This parameter can be a combination of the following values: MSIO_PIN_0 MSIO_PIN_1 MSIO_PIN_2 MSIO_PIN_3 MSIO_PIN_4 MSIO_PIN_ALL

## ◆ hal_msio_init_ext()

void hal_msio_init_ext | ( | msio_pad_t | MSIOx,
|  | msio_init_t * | p_msio_init
| ) |  |

Initialize the MSIOx peripheral according to the specified parameters in the msio_init_t.

Note
  The function will call the hal_msio_init function to initialize the HAL MSIO.

Parameters

  [in] | MSIOx | MSIO peripheral port.
  [in] | p_msio_init | Pointer to an msio_init_t structure that contains the configuration information for the specified MSIO peripheral port.

## ◆ hal_msio_register_callback()

void hal_msio_register_callback | ( | hal_msio_callback_t * | msio_callback | ) |

This function registers the callback function to the ROM area.

Note
  This function needs to be called before hal_msio_init.

Parameters

  [in] | msio_callback | Pointer to callback structure function. hal_msio_callback_t

## ◆ hal_pwm_deinit_ext()

hal_status_t hal_pwm_deinit_ext | ( | pwm_handle_t * | p_pwm | ) |

De-initialize the PWM peripheral.

Parameters

  [in] | p_pwm | Pointer to a PWM handle that contains the configuration information for the specified PWM module.

Note
  The function will call the hal_pwm_deinit function to De-initialize the HAL PWM.

Return values

  HAL_OK | Operation is OK.
  HAL_ERROR | Parameter error or operation not supported.
  HAL_BUSY | Driver is busy.
  HAL_TIMEOUT | Timeout occurred.

## ◆ hal_pwm_init_ext()

hal_status_t hal_pwm_init_ext | ( | pwm_handle_t * | p_pwm | ) |

Initialize the PWM mode according to the specified parameters in the pwm_init_t and initialize the associated handle.

Parameters

  [in] | p_pwm | Pointer to a PWM handle that contains the configuration information for the specified PWM module.

Note
  The function will call the hal_pwm_init function to initialize the HAL PWM.

Return values

  HAL_OK | Operation is OK.
  HAL_ERROR | Parameter error or operation not supported.
  HAL_BUSY | Driver is busy.
  HAL_TIMEOUT | Timeout occurred.

## ◆ hal_pwm_register_callback()

void hal_pwm_register_callback | ( | hal_pwm_callback_t * | pwm_callback | ) |

This function registers the callback function to the ROM area.

Note
  This function needs to be called before hal_pwm_init.

Parameters

  [in] | pwm_callback | Pointer to callback structure function. hal_pwm_callback_t

## ◆ hal_pwr_config_timer_wakeup_ext()

hal_status_t hal_pwr_config_timer_wakeup_ext | ( | uint8_t | mode,
|  | uint32_t | value
| ) |  |

Configure the AON Sleep Timer mode, count and start used to wakeup MCU.

Parameters

  [in] | mode | Specifies the sleep timer mode. This parameter can be a combination of the following values: PWR_SLP_TIMER_MODE_NORMAL PWR_SLP_TIMER_MODE_SINGLE PWR_SLP_TIMER_MODE_RELOAD
  [in] | value | Count value of the AON Sleep Timer.

Note
  The function will call the hal_sleep_timer_config_and_start function to initialize the HAL SLEEP TIMER.

Return values

  HAL_OK | Operation is OK.
  HAL_BUSY | Driver is busy.

Note
  The sleep clock of AON Timer is 32 KHz.

## ◆ hal_pwr_register_timer_elaspsed_handler()

void hal_pwr_register_timer_elaspsed_handler | ( | pwr_slp_elapsed_handler_t | pwr_slp_elapsed_hander | ) |

This function registers the callback function to the ROM area.

Parameters

  [in] | pwr_slp_elapsed_hander | Pointer to callback structure function. pwr_slp_elapsed_handler_t

## ◆ hal_register_callback()

void hal_register_callback | ( | hal_callback_t * | hal_callback | ) |

This function registers the callback function to the ROM area.

Note
  This function needs to be called before hal_init.

Parameters

  [in] | hal_callback | Pointer to callback structure function. hal_callback_t

## ◆ hal_rng_deinit_ext()

hal_status_t hal_rng_deinit_ext | ( | rng_handle_t * | p_rng | ) |

De-initialize the RNG peripheral.

Parameters

  [in] | p_rng | RNG handle.

Note
  The function will call the hal_rng_deinit function to De-initialize the HAL RNG.

Return values

  HAL_OK | Operation is OK.
  HAL_ERROR | Parameter error or operation not supported.
  HAL_BUSY | Driver is busy.
  HAL_TIMEOUT | Timeout occurred.

## ◆ hal_rng_init_ext()

hal_status_t hal_rng_init_ext | ( | rng_handle_t * | p_rng | ) |

Initialize the RNG according to the specified parameters in the rng_init_t of associated handle.

Parameters

  [in] | p_rng | Pointer to a RNG handle which contains the configuration information for the specified RNG module.

Note
  The function will call the hal_rng_init function to initialize the HAL RNG.

Return values

  HAL_OK | Operation is OK.
  HAL_ERROR | Parameter error or operation not supported.
  HAL_BUSY | Driver is busy.
  HAL_TIMEOUT | Timeout occurred.

## ◆ hal_rng_register_callback()

void hal_rng_register_callback | ( | hal_rng_callback_t * | rng_callback | ) |

This function registers the callback function to the ROM area.

Note
  This function needs to be called before hal_rng_init.

Parameters

  [in] | rng_callback | Pointer to callback structure function. hal_rng_callback_t

## ◆ hal_spi_deinit_ext()

hal_status_t hal_spi_deinit_ext | ( | spi_handle_t * | p_spi | ) |

De-initialize the SPI peripheral.

Parameters

  [in] | p_spi | Pointer to an SPI handle which contains the configuration information for the specified SPI module.

Note
  The function will call the hal_spi_deinit function to De-initialize the HAL SPI.

Return values

  HAL_OK | Operation is OK.
  HAL_ERROR | Parameter error or operation not supported.
  HAL_BUSY | Driver is busy.
  HAL_TIMEOUT | Timeout occurred.

## ◆ hal_spi_init_ext()

hal_status_t hal_spi_init_ext | ( | spi_handle_t * | p_spi | ) |

Initialize the SPI according to the specified parameters in the spi_init_t and initialize the associated handle.

Parameters

  [in] | p_spi | Pointer to an SPI handle which contains the configuration information for the specified SPI module.

Note
  The function will call the hal_spi_init function to initialize the HAL SPI.

Return values

  HAL_OK | Operation is OK.
  HAL_ERROR | Parameter error or operation not supported.
  HAL_BUSY | Driver is busy.
  HAL_TIMEOUT | Timeout occurred.

## ◆ hal_spi_register_callback()

void hal_spi_register_callback | ( | hal_spi_callback_t * | spi_callback | ) |

This function registers the callback function to the ROM area.

Note
  This function needs to be called before hal_spi_init.

Parameters

  [in] | spi_callback | Pointer to callback structure function. hal_spi_callback_t

## ◆ hal_timer_base_deinit_ext()

hal_status_t hal_timer_base_deinit_ext | ( | timer_handle_t * | p_timer | ) |

De-initialize the TIMER peripheral.

Parameters

  [in] | p_timer | Pointer to a TIMER handle which contains the configuration information for the specified TIMER module.

Note
  The function will call the hal_timer_base_deinit function to De-initialize the HAL TIM.

Return values

  HAL_OK | Operation is OK.
  HAL_ERROR | Parameter error or operation not supported.
  HAL_BUSY | Driver is busy.
  HAL_TIMEOUT | Timeout occurred.

## ◆ hal_timer_base_init_ext()

hal_status_t hal_timer_base_init_ext | ( | timer_handle_t * | p_timer | ) |

Initialize the TIMER according to the specified parameters in the timer_init_t and initialize the associated handle.

Parameters

  [in] | p_timer | Pointer to a TIMER handle which contains the configuration information for the specified TIMER module.

Note
  The function will call the hal_timer_base_init function to initialize the HAL TIM.

Return values

  HAL_OK | Operation is OK.
  HAL_ERROR | Parameter error or operation not supported.
  HAL_BUSY | Driver is busy.
  HAL_TIMEOUT | Timeout occurred.

## ◆ hal_timer_register_callback()

void hal_timer_register_callback | ( | hal_timer_base_callback_t * | timer_base_callback | ) |

This function registers the callback function to the ROM area.

Note
  This function needs to be called before hal_timer_base_init.

Parameters

  [in] | timer_base_callback | Pointer to callback structure function. hal_timer_base_callback_t

## ◆ hal_uart_deinit_ext()

hal_status_t hal_uart_deinit_ext | ( | uart_handle_t * | p_uart | ) |

De-initialize the UART peripheral.

Parameters

  [in] | p_uart | Pointer to a UART handle which contains the configuration information for the specified UART module.

Note
  The function will call the hal_uart_deinit function to De-initialize the HAL UART.

Return values

  HAL_OK | Operation is OK.
  HAL_ERROR | Parameter error or operation not supported.
  HAL_BUSY | Driver is busy.
  HAL_TIMEOUT | Timeout occurred.

## ◆ hal_uart_init_ext()

hal_status_t hal_uart_init_ext | ( | uart_handle_t * | p_uart | ) |

Initialize the UART according to the specified parameters in the uart_init_t and initialize the associated handle.

Parameters

  [in] | p_uart | Pointer to a UART handle which contains the configuration information for the specified UART module.

Note
  The function will call the hal_uart_init function to initialize the HAL UART.

Return values

  HAL_OK | Operation is OK.
  HAL_ERROR | Parameter error or operation not supported.
  HAL_BUSY | Driver is busy.
  HAL_TIMEOUT | Timeout occurred.

## ◆ hal_uart_register_callback()

void hal_uart_register_callback | ( | hal_uart_callback_t * | uart_callback | ) |

This function registers the callback function to the ROM area.

Note
  This function needs to be called before hal_uart_init.

Parameters

  [in] | uart_callback | Pointer to callback structure function. hal_uart_callback_t

## ◆ hal_wdt_deinit_ext()

hal_status_t hal_wdt_deinit_ext | ( | wdt_handle_t * | p_wdt | ) |

De-initialize the WDT peripheral.

Parameters

  [in] | p_wdt | WDT handle.

Note
  The function will call the hal_wdt_deinit function to De-initialize the HAL WDT.

Return values

  HAL_OK | Operation is OK.
  HAL_ERROR | Parameter error or operation not supported.
  HAL_BUSY | Driver is busy.
  HAL_TIMEOUT | Timeout occurred.

## ◆ hal_wdt_init_ext()

hal_status_t hal_wdt_init_ext | ( | wdt_handle_t * | p_wdt | ) |

Initialize the WDT according to the specified parameters in the wdt_init_t of associated handle.

Parameters

  [in] | p_wdt | Pointer to a WDT handle which contains the configuration information for the specified WDT module.

Note
  The function will call the hal_wdt_init function to initialize the HAL WDT.

Return values

  HAL_OK | Operation is OK.
  HAL_ERROR | Parameter error or operation not supported.
  HAL_BUSY | Driver is busy.
  HAL_TIMEOUT | Timeout occurred.

## ◆ hal_wdt_register_callback()

void hal_wdt_register_callback | ( | hal_wdt_callback_t * | wdt_callback | ) |

This function registers the callback function to the ROM area.

Note
  This function needs to be called before hal_wdt_init.

Parameters

  [in] | wdt_callback | Pointer to callback structure function. hal_wdt_callback_t

## ◆ hal_xqspi_deinit_ext()

hal_status_t hal_xqspi_deinit_ext | ( | xqspi_handle_t * | p_xqspi | ) |

De-initialize the XQSPI peripheral.

Parameters

  [in] | p_xqspi | Pointer to an XQSPI handle which contains the configuration information for the specified XQSPI module.

Note
  The function will call the hal_xqspi_deinit function to De-initialize the HAL XQSPI.

Return values

  HAL_OK | Operation is OK.
  HAL_ERROR | Parameter error or operation not supported.
  HAL_BUSY | Driver is busy.
  HAL_TIMEOUT | Timeout occurred.

## ◆ hal_xqspi_init_ext()

hal_status_t hal_xqspi_init_ext | ( | xqspi_handle_t * | p_xqspi | ) |

Initialize the XQSPI according to the specified parameters in the xqspi_init_t and initialize the associated handle.

Parameters

  [in] | p_xqspi | Pointer to an XQSPI handle which contains the configuration information for the specified XQSPI module.

Note
  The function will call the hal_xqspi_init function to initialize the HAL XQSPI.

Return values

  HAL_OK | Operation is OK.
  HAL_ERROR | Parameter error or operation not supported.
  HAL_BUSY | Driver is busy.
  HAL_TIMEOUT | Timeout occurred.

## ◆ hal_xqspi_register_callback()

void hal_xqspi_register_callback | ( | hal_xqspi_callback_t * | xqspi_callback | ) |

This function registers the callback function to the ROM area.

Note
  This function needs to be called before hal_wdt_init.

Parameters

  [in] | xqspi_callback | Pointer to callback structure function. hal_xqspi_callback_t